#include <iostream>
#include <cstdio>
#include <ctime>

using namespace std;

int n, q;
int a[50005];
int tip, l, r, a1, b;
int rez;

int main()
{
    freopen("pijaca.in", "r", stdin);
    freopen("pijaca.out", "w", stdout);
    int i;
    int j;
    scanf("%i", &n);
    for(i=0; i<n; ++i)
        scanf("%i", &a[i]);
    scanf("%i", &q);
    for(i=0; i<q; i++)
    {
        scanf("%i", &tip);
        if(tip==1)
        {
            rez=0;
            scanf("%i %i %i %i", &l, &r, &a1, &b);
            l--;
            r--;
            for(j=l; j<=r; j++)
                if(a[j]>=a1 && a[j]<=b)
                    rez++;
            printf("%i\n", rez);
        }
        else
        {
            scanf("%i %i", &l, &r);
            l--;
            a[l]=r;
        }
    }
    return 0;
}
